var el = wp.element.createElement;
var aphphIcon = wp.element.createElement('svg', 
	{ 
        "aria-hidden": "true",
        role: "img",
        focusable: "false",
        viewBox: "0 0 512 512",
        width: "24",
        height: "24"
	},
	wp.element.createElement( 'path',
		{ 
			d: "M64 416l192-320 192 320z"
		}
	)
);

function encodeEntities(input) {
	encoded = jQuery('<textarea>').html(input).html();
	return encoded;
}

wp.blocks.registerBlockType('aphph/prism-block', {
 
   title: 'APH Prism',

   icon: aphphIcon,

   category: 'common',

   attributes: {

		language: { type: 'string', default: aphph_default_lang }, 
		content: { type: 'string', source: 'text', selector: 'code' },
		attrClass: { type: 'string', source: 'attribute', selector: 'pre', attribute: 'class'},
		highlightLineNumber: { type: 'string', source: 'attribute', selector: 'pre', attribute: 'data-line', default: ''},
		startingLineNumber: { type: 'string', source: 'attribute', selector: 'pre', attribute: 'data-start', default: ''}
   },
   
   edit: function(props) {
	  
	   if (props.attributes.attrClass) {
		   list_class = props.attributes.attrClass.split(' ');
		   for (k in list_class) {
			   if (list_class[k].indexOf(':') > 0) {
				   split_data = list_class[k].split(':');
				   selected_lang = jQuery.trim(split_data[1]);
				   props.attributes.language = jQuery.trim(split_data[1]);
			   }
		   }
		   props.attributes.attrClass = '';
	   }
	   
	   selected_lang = props.attributes.language;
	   
	   function updateHighlightLine( event ) {
		  props.setAttributes( { highlightLineNumber: event.target.value } );
	   } 
	   function updateStartingLineNumber( event ) {
		  props.setAttributes( { startingLineNumber: event.target.value } );
	   }

	   function updateContent( event ) {
		  props.setAttributes( { content:  event.target.value } );
	   }

	   function updateLanguage( event ) {
		  props.setAttributes( { language: event.target.value } );
	   }
	   
	   function buildLangOptions() {
		   lang_list = JSON.parse(aphph_lang_list);
		   option = [];
		   for (k in lang_list) {
			   val_selected  = k == aphph_default_lang ? 'SELECTED' : '';
			   option.push(el("option", {value: k, selected: true}, lang_list[k]))
		   }
		   return option;	
	   }
	   
	   $element = el( 'div',
			  {
				 className: 'aphph-block-wrapper'
			  },
				el(
					 'select',
					 {
						onChange: updateLanguage,
						'data-lang': selected_lang,
						value: selected_lang
					 },
						 buildLangOptions()
					
				  ),
				  el(
					 'textarea',
					 {
						placeholder: 'Enter code here...',
						rows: 10,
						className: 'aphph-block-textarea',
						onChange: updateContent,
						style: { width: '100%' },
					 }, props.attributes.content
					 
				  ),
				  el(
					 'input',
					 {
							help: 'Highlight line number',
							type: 'text',
							placeholder: 'Highlight line number',
							onChange: updateHighlightLine,
							value: props.attributes.highlightLineNumber
					 }
				  ),
				  
				  el(
					 'input',
					 {
							label: 'Start line number',
							type: 'text',
							placeholder: 'Starting line number',
							value: props.attributes.startingLineNumber,
							onChange: updateStartingLineNumber
					 }
				  )
	   ); // End return
	   
		return $element;
		return null;
   },

   save: function(props) {

		attr = {className: 'lang:'  + props.attributes.language + ' language-' + props.attributes.language};
		if (props.attributes.highlightLineNumber) {
			attr["data-line"] = props.attributes.highlightLineNumber;
		}
		
		if (props.attributes.startingLineNumber) {
			attr["data-start"] = props.attributes.startingLineNumber;
		}
	  
	   
	  return el( 'pre',
			 attr
		  ,
		  el(
			 'code',
			 null,
			 encodeEntities(props.attributes.content)
		  )

	   ); // End return
      return null;
   }
});

wp.domReady(function() {
	
	$select = jQuery('.aphph-block-wrapper').find('select');
	$elm = document.querySelectorAll('.aphph-block-wrapper');
	
	$select.each(function(i, elm) {
		
		$elm = jQuery(elm);
		lang = $elm.attr('data-lang');
		$elm.find('option[value="'+lang+'"]').prop('selected',true);
		$elm.find('option[value="'+lang+'"]').attr('selected','selected');
	});
	
	// textarea = jQuery(".aphph-block-textarea");
	// tabOverride.set(textarea);
	jQuery(document).delegate(".aphph-block-textarea", 'keydown', tabOverride.handlers.keydown);
	jQuery(document).delegate(".aphph-block-textarea", 'keypress', tabOverride.handlers.keypress);
});